package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.UserRoleDEFields;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleDEFields_Grid_Main{
    private String userroledefieldsid;
    private String userroledefieldid;
    private String updateman;
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Timestamp updatedate;
    private String userroledefieldsname;
    private String srfmajortext;


    private String srfdataaccaction;


    private String srfkey;


    private String userroleid;
    public  void fromUserRoleDEFields(UserRoleDEFields sourceEntity)  {
         this.setUserroledefieldsid(sourceEntity.getUserroledefieldsid());
         this.setUserroledefieldid(sourceEntity.getUserroledefieldid());
         this.setUpdateman(sourceEntity.getUpdateman());
         this.setUpdatedate(sourceEntity.getUpdatedate());
         this.setUserroledefieldsname(sourceEntity.getUserroledefieldsname());
         this.setSrfmajortext(sourceEntity.getUserroledefieldsname());
         this.setSrfdataaccaction(sourceEntity.getUserroledefieldsid());
         this.setSrfkey(sourceEntity.getUserroledefieldsid());
         this.setUserroleid(sourceEntity.getUserroleid());
	}

	public static Page<UserRoleDEFields_Grid_Main> fromUserRoleDEFields(Page<UserRoleDEFields> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<UserRoleDEFields_Grid_Main> targetpage=new Page<UserRoleDEFields_Grid_Main>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<UserRoleDEFields_Grid_Main> records=new ArrayList<UserRoleDEFields_Grid_Main>();
        for(UserRoleDEFields source:sourcePage.getRecords()) {
            UserRoleDEFields_Grid_Main target=new UserRoleDEFields_Grid_Main();
            target.fromUserRoleDEFields(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("userroledefieldsname","用户角色相关实体属性访问控制"); }});
        columnModelList.add(new HashMap(){ { put("updateman","更新人"); }});
        columnModelList.add(new HashMap(){ { put("updatedate","更新时间"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<UserRoleDEFields> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(UserRoleDEFields source:searchResult.getRecords()) {
            UserRoleDEFields_Grid_Main target=new UserRoleDEFields_Grid_Main();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<UserRoleDEFields> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}